﻿using System;

namespace TestApp
{
    public class TData : NotificationObject
    {
        #region Properties

        #region Int

        private int _intData;

        public int Int
        {
            get
            {
                return this._intData;
            }

            set
            {
                this._intData = value;
                this.RaisePropertyChanged(() => this.Int);
            }
        }

        #endregion // Int

        #region Double

        private double _doubleData;

        public double Double
        {
            get
            {
                return this._doubleData;
            }

            set
            {
                this._doubleData = value;
                this.RaisePropertyChanged(() => this.Double);
            }
        }

        #endregion // Double

        #region Bool

        private bool _boolData;

        public bool Bool
        {
            get
            {
                return this._boolData;
            }

            set
            {
                this._boolData = value;
                this.RaisePropertyChanged(() => this.Bool);
            }
        }

        #endregion // Bool

        #region String

        private string _stringData;

        public string String
        {
            get
            {
                return this._stringData;
            }

            set
            {
                this._stringData = value;
                this.RaisePropertyChanged(() => this.String);
            }
        }

        #endregion // String

        #region DateTime

        private DateTime _dateTimeData;

        public DateTime DateTime
        {
            get
            {
                return this._dateTimeData;
            }

            set
            {
                this._dateTimeData = value;
                this.RaisePropertyChanged(() => this.DateTime);
            }
        }

        #endregion // DateTime

        #region Uri

        private Uri _uriData;

        public Uri Uri
        {
            get
            {
                return this._uriData;
            }

            set
            {
                this._uriData = value;
                this.RaisePropertyChanged(() => this.Uri);
            }
        }

        #endregion // Uri

        #region DataItems

        private TDataCollection _dataItems;

        public TDataCollection DataItems
        {
            get
            {
                if (this._dataItems == null)
                {
                    this._dataItems = new TDataCollection();
                }

                return this._dataItems;
            }

            set
            {
                this._dataItems = value;
                this.RaisePropertyChanged(() => this.DataItems);
            }
        }

        #endregion // DataItems

        #endregion // Properties
    }
}
