﻿using System.Windows;
using System.Windows.Controls;

namespace TestApp
{
    public partial class MainPage : UserControl
    {
        private readonly TestViewModel _viewModel;

        public MainPage()
        {
            this.InitializeComponent();
            this._viewModel = new TestViewModel();
            this.DataContext = this._viewModel;
        }

        private void Green_Button_Click(object sender, RoutedEventArgs e)
        {
            this.XGrid.ActiveCell.Style = this.XGrid.Resources["GreenCellStyle"] as Style;
        }

        private void Red_Button_Click(object sender, RoutedEventArgs e)
        {
            this.XGrid.ActiveCell.Style = this.XGrid.Resources["RedCellStyle"] as Style;
        }

        private void Clear_Button_Click(object sender, RoutedEventArgs e)
        {
            this.XGrid.ActiveCell.Style = null;
        }
    }
}
